/*** Constants ****/
#define MAX_RECORD_SIZE   (3 + 256 + 4096)
#define CUSTOM_FIELD_SIZE 16


/*********************** CALL BACK STUFF ***************************/
register void *reg_a4 asm ("%a4");
#define CALL_PROLOGUE  void *save_a4=reg_a4; asm("move.l %%a5,%%a4; sub.l #edata ,%%a4" \
 	 : : ); 
#define CALL_EPILOGUE reg_a4 = save_a4; 
 



typedef enum { Label = 1 , Field = 2 , Goto = 3 , NewLine = 4 , TrueFalse = 5 , 
	       List = 6 , End = 7 } ctlClass ;


typedef union {
   char Text[50];
   CharPtr LstItems[10];
} FldData;

/* Field Descriptor */
typedef struct
{
   int Class;
   char ID[24];
   FldData Data;
} ctlDef;  


#define FRM_MAXFIELD 50
ctlDef nForm [ FRM_MAXFIELD ];


int  StartToCommunicate (int Form );
void SendWord ( char * Word ); 
int  GetDefinitions ();
void CloseCommunication ();

int ProcessField ( int Num ,  CharPtr Fld );
int RecvForm ( CharPtr Name );




 
extern const unsigned short appVersionNum ;
extern const unsigned short appPrefID ;
extern const unsigned short appPrefVersionNum ;


