#include <Str.h>
#include <DebugWnd.h>
#include <callback.h>
#include <CntXFer.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
/*
 * Definitions for Socket libraries
 */
#include        <sys/types.h>
#include        <sys/socket.h>
#include        <netinet/in.h>
#include        <arpa/inet.h>

#define LOCATOR_ADDRESS "127.0.0.1"
#define LOCATOR_PORT 6001
#define REPLY_PORT 6002

typedef struct 
{
  char * ID;
  char * Hood;
} CellHood;


CellHood Hoods []
  =
   {
      {"2976X65534X18X25"  , "UMBC",			},
      {"2976X65534X18X115" , "Frederick Road",		},
      {"2976X65534X18X135" , "Charles Street",		},
      {"2976X65534X18X645" , "Charles Street",		},
      {"2976X65534X18X8"   , "Federal Hill",		},
      {"2976X65534X18X8"   , "Federal Hill",		},
      {"3232X0X3232X45656"           , "DowntownFortWorth",	   	        },
      {"3232X0X3232X19880"           , "DowntownFortWorth",	   	        },
      {"3232X0X3232X-19880"           , "DowntownFortWorth",	   	        },
      {"3232X0X3232X-19879"           , "DowntownFortWorth",	   	        },
      {"3232X0X3232X19879"           , "DowntownFortWorth",	   	        },
      {"0X0X0X0"           , "Unknown",	   	        },
      {NULL		  , NULL			}
   };


char UserName[40] = "";

/*------------------------------------*/
/*------------------------------------*/
int ReplyToFormRequest ( char * From , char * Form )
{
   FILE * form;
   char * cellID;
   char * Hood = NULL;
   char Buff[2024];
   PRINTF ( "Replying to Form request for  '%s'" , Form );

   

   /* Check if the form Exist */

   cellID = strchr ( Form , ';' );

  if ( cellID != NULL )
  {
   *cellID = 0; cellID++;
   printf ( "This guy is at %s \n" , cellID );

   /// Now let's find which hood the dude is in...

   if ( cellID[0] == 'I' &&
        cellID[1] == 'D' &&
        cellID[2] == '=' )
   {
        int i;
        cellID += 3;
     
        printf ( "CELL ID is %s\n" , cellID );

	for ( i = 0 ; Hoods[i].Hood != NULL ; i++ )
	   if ( !strcmp ( Hoods[i].ID , cellID ))
	       {  Hood = Hoods[i].Hood; break; }

        printf ( "Hood = %s \n" , Hood );
   }
  }

   form = fopen ( Form , "r" );
   CntMsgInitObj ( &cntDta.Send ,  From );
    cntDta.Send.TimeStamp = cntDta.timeTick+1;

   CntMsgAddToObj ( &cntDta.Send , "F|" );
  
   if ( form == NULL )
   {
 	CntMsgAddToObj ( &cntDta.Send , "Label: 1 : " );
 	CntMsgAddToObj ( &cntDta.Send , "Could not find requested form " );
 	CntMsgAddToObj ( &cntDta.Send , Form );
 	CntMsgAddToObj ( &cntDta.Send , "\nNewline : :\n" );

 	CntMsgAddToObj ( &cntDta.Send , "Label: 1 : " );
 	CntMsgAddToObj ( &cntDta.Send , "request for some reason.\n" );
 	CntMsgAddToObj ( &cntDta.Send , "Newline : :\n" );
   }
   else
   {
   /* Read the form and transmit it to the Client */
 
      while ( !feof(form))
      {
	 int n; char *Zip;
	 n = fread ( Buff , 1 , sizeof(Buff)-6 , form );
	 printf ( "Sending %s" , Buff );
	 Buff[n] = 0;
	 Zip = strstr ( Buff , "Zip:" );
	 if ( Zip != NULL )
	 {
	     printf ( "Zip is %s \n" , Zip );
	     *Zip = 0; Zip += 4;
	     printf ( "======================================\n");
	     printf ( "Buff is : %s \n" , Buff );
	     printf ( "Zip:" );
	     printf ( "Hood is : %s \n" , Hood );
	     printf ( "Zip  is : %s \n" , Zip );
	     printf ( "======================================\n");
	     CntMsgAddToObj ( &cntDta.Send , Buff );
	     CntMsgAddToObj ( &cntDta.Send , "Zip:" );
	     CntMsgAddToObj ( &cntDta.Send , Hood );
	     CntMsgAddToObj ( &cntDta.Send , Zip  );
         }
	 else
	 CntMsgAddToObj ( &cntDta.Send , Buff );
      }
   }
}

/*------------------------------------*/
/*------------------------------------*/

char * RequestFile = "/tmp/RequestFile";
char * ReplyFile   = "/tmp/ReplyFile";

char * ReplyProgram = "/vlad/home/hchen4/Agents2Go/classes/runit.sh";

/*------------------------------------*/
/*------------------------------------*/
int ReplyToDataRequest ( char * From , char * Data )
{

   char Buff[1024];
   int sockfd = -1;
   int fail = 0;

   PRINTF ( "--------->Replying to Data request for \n|%s|\n<------------->" , Data );


	/* I need to send a question to the server */

   fail = SendFormtoLocator(Data, LOCATOR_ADDRESS, LOCATOR_PORT);

   sockfd = ReceiveConnectionRequestFromBroker(REPLY_PORT); 	 	
  
   if( sockfd < 0) 
	fail = -1;	

   CntMsgInitObj ( &cntDta.Send ,  From );
   cntDta.Send.TimeStamp = cntDta.timeTick+1;



   CntMsgAddToObj ( &cntDta.Send , "R|" );

   if ( fail  )
   {
        CntMsgAddToObj ( &cntDta.Send , "Label: 1 : " );
        CntMsgAddToObj ( &cntDta.Send , "Could not process your\n" );
        CntMsgAddToObj ( &cntDta.Send , "Newline : :\n" );

        CntMsgAddToObj ( &cntDta.Send , "Label: 1 : " );
        CntMsgAddToObj ( &cntDta.Send , "request for some reason.\n" );
        CntMsgAddToObj ( &cntDta.Send , "Newline : :\n" );
   }
   else
   {


      while(1) {
	int n;
	n = ReadFromBrokerintoBuffer(sockfd,Buff);
	if(n == 0) break;
	Buff[n] = 0;
	CntMsgAddToObj (&cntDta.Send, Buff);
      }		 	
      close(sockfd); 
   }
}


/*------------------------------------*/
/*------------------------------------*/


int ReplyToMessage  ( char * From ,  char * Msg )
{
  /* Message Reply thing */
  char Request[88];
  int stPtr = 0;

  PRINTF ( "Replying to %s \n" , Msg );

  /* Start Parsing */

  /* Does message start with | ? */

  if ( * Msg != '|' ) return -1;

  Msg++;

  while ( *Msg != '\0'  &&
	  *Msg != '|' )
  {
     Request[stPtr++] = *Msg;
     if ( stPtr > 80 ) return -1;
     Msg++;
  }
  if ( *Msg == 0 ) return -1;
  if ( *Msg != '|' ) return -1;

  Msg++;
  Request[stPtr] = 0;

  PRINTF ( "Command is %s \n" , Request );

  if ( !strcmp ( Request , "FormRequest" )) 
		ReplyToFormRequest ( From , Msg );
  if ( !strcmp ( Request , "FormData" )) 
		ReplyToDataRequest ( From , Msg );
  
  return 0;
}

/*------------------------------------*/
/*------------------------------------*/

void CntMessageReceived ( int i )
{

   char SendTo[40];
   CntMsgObj * msgObj =  &cntDta.Rcv[i];
   int c;
   int usrDone = 0;
   int m;
   int j = 0;

   char Message[16000];

   memset ( Message , 0 , sizeof(Message));

   PRINTF ( "CENTAURUS MESSAGE HAS BEEN RECEIVED " );
   PRINTF ( "MESSAGE #### %d " , i );

   PRINTF ( "Message Received\nObj %s \nTime %d \nSize %d",
	      msgObj->Id , msgObj->TimeStamp, msgObj->Size );
   i = 0;
   
   PRINTF ( "Message is\n--------------------------------------");
     while ( c = CntMsgNextChar ( msgObj ) ) 
	{
	   if ( c == '|' ) usrDone = -1;
	   if ( !usrDone )  SendTo[i++] = c; 
		      else  Message[j++] = c;
	   putchar ( c );
	}
   PRINTF ( "\n--------------------------------------");
   SendTo[i] = 0;
   Message[j] = 0;

#ifdef SERVER
   i = CntDevForUser (SendTo);
#else
   i = 0;
#endif

   if ( i == -1 ) { PRINTF ("INVALID USER %s " , SendTo ); return ; }

   /* Find out what we have we either have a request for form or
      we have something else
    */
    
   PRINTF ( "The message body is\n---------------\n%s\n-------------",
	    Message );

   PRINTF ( "Context is %d " , i );

#ifdef SERVER
    SwitchContext ( i );
#endif

   if ( ReplyToMessage ( SendTo, Message ) ) PRINTF ( "BAD RESULTS" );

#ifdef SERVER
   SwitchContext ( i );
#endif

   PRINTF ( "Sending to %s at %d \n" , SendTo , i );
   
}

/*------------------------------------*/
/*------------------------------------*/

int ObjAcptCallback ( char * Name )
{
  printf ( "Accepting New Client  %s \n" , Name );
  ObjAccept ( Name );

}

/*------------------------------------*/
/*------------------------------------*/

int main ()

{
   int i, actCode;


   puts ( "Testing UDP/Centaurus" );



   /* Start-Up Centaurus */
   CntStart ();

   ObjNewObjSetCb   ( &cntDta ,  ObjAcptCallback );

 //   ObjAccept ( "FormRequest" );
 //   ObjAccept ( "FormData" );
   

   for ( ;; )
   {
     /* This should go to the nilEvent processing */
	
	for ( i = 0 ; i < MAX_OBJECTS ; i ++ )
	{
	     if ( cntDta.Completed[i] != 0 )
	     {
		 CntMessageReceived ( i );
		cntDta.Completed [i] = 0;
	     }
	}

 switch ( actCode = CntXFerAction () )
	{
	case cntActNone:
		break;
	case cntActSetName:
	  puts ( "Set Name" );
	       printf ( "Enter username " );
	       strcpy ( UserName , "A2GoServer" );
	       CntSetUserName ( UserName );
	  break;

	case cntActUpdateDiscovery:
	  // printf ( "Discovery Timeout is in %d \n" , cntDta.DiscoveryTimeout );
	  break;

#ifdef SERVER
	case cntActUpdateDevicelist:
	  puts ( "Active Devices :" );
	
	  for ( i = 0 ; i < cntDta.nGoodDevices ; i ++ )
	  {
	     printf ( "   Device :  %s \n" , cntDta.DeviceList[i] );
	  }

	  break;	  
#endif
		
	default:
	  PRINTF ( "PANIC: Unkown Action %d requested " , actCode );
	  
         }
      

   }

}

/*------------------------------------------------*/

int SendFormtoLocator(char *Data, char *server_address, int server_port) {

	int                     sockfd;
        struct sockaddr_in      serv_addr;
	int datalen, datalensent;

        /*
         * Fill in the structure "serv_addr" with the address of the
         * server that we want to connect with.
         */

        bzero((char *) &serv_addr, sizeof(serv_addr));
        serv_addr.sin_family      = AF_INET;
        serv_addr.sin_addr.s_addr = inet_addr(server_address);
        serv_addr.sin_port        = htons(server_port);

        /*
         * Open a TCP socket (an Internet stream socket).
         */

        if ( (sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
                printf("Erro: Cannot create socket to Locator\n");
		return -1;
	}
        /*
         * Connect to the locator.
         */

        if (connect(sockfd, (struct sockaddr *) &serv_addr,
                                                        sizeof(serv_addr)) < 0) {
                printf("Error: Cannot Connect to Locator\n");
		return -1;
	}

	datalen = strlen(Data);
	printf("Sending Data to the Locator...");
	
	datalensent = send(sockfd,Data,datalen,0); 	
        close(sockfd);

	if( datalen != datalensent) return -1;

	return 0;
}
/**
 * This function should open a socket and accept the connection for the
 * reply from a broker.
 * This function returns the Socket Descriptor for the accepted connection.
 */
int ReceiveConnectionRequestFromBroker(int reply_port) {

	int sockfd, newsockfd, brokerlen;
	struct sockaddr_in my_addr, broker_addr;	

        if ( (sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
                printf("Error: can't open stream socket to listen for replies\n");
		return -1;
	}

        /*
         * Bind our local address so that the broker can send to us.
         */

        bzero((char *) &my_addr, sizeof(my_addr));
        my_addr.sin_family      = AF_INET;
        my_addr.sin_addr.s_addr = htonl(INADDR_ANY);
        my_addr.sin_port        = htons(reply_port);

        if (bind(sockfd, (struct sockaddr *) &my_addr, sizeof(my_addr)) < 0) {
		printf("Error: Cannot bind to port %d",reply_port);
		return -1;
	}

        listen(sockfd, 5);

        printf("Client wating for stuff");

	brokerlen = sizeof(broker_addr);
        newsockfd = accept(sockfd, (struct sockaddr *) &broker_addr,&brokerlen);
	
	close(sockfd) ;

	return newsockfd;
}

/**
 * This function reads from the specified socket into the specified buffer.
 * It returns the number of characters read.
 */
int ReadFromBrokerintoBuffer(int sockfd, char * Buff) {
	
	int n;	
	n = recv(sockfd, Buff, sizeof(Buff), 0);
	return n;

}
