#include <Str.h>
#include <DebugWnd.h>
#include <callback.h>
#include <CntXFer.h>
#include <stdlib.h>
#include <stdio.h>

char UserName[40] = "";

int ReplyToXmlRequest  ( char * From , char * Form ) 
{
   FILE * form;
   char Buff[8192];
   PRINTF ( "Replying to XML request for  '%s'" , Form );

   form = fopen ( Form , "r" );
   CntMsgInitObj ( &cntDta.Send ,  From );
    cntDta.Send.TimeStamp = cntDta.timeTick+1;
   CntMsgAddToObj ( &cntDta.Send , "X|" );

   while ( !feof(form))
      {
	 int n;
	 n = fread ( Buff , 1 , sizeof(Buff)-6 , form );
	 printf ( "Sending %s" , Buff );
	 Buff[n] = 0;
	 CntMsgAddToObj ( &cntDta.Send , Buff );
      }

}

int ReplyToFormRequest ( char * From , char * Form )
{
   FILE * form;
   char Buff[1024];
   PRINTF ( "Replying to Form request for  '%s'" , Form );


   /* Check if the form Exist */


   form = fopen ( Form , "r" );
   CntMsgInitObj ( &cntDta.Send ,  From );
    cntDta.Send.TimeStamp = cntDta.timeTick+1;

   CntMsgAddToObj ( &cntDta.Send , "F|" );
  
   if ( form == NULL )
   {
 	CntMsgAddToObj ( &cntDta.Send , "Label: 1 : " );
 	CntMsgAddToObj ( &cntDta.Send , "Could not find requested form " );
 	CntMsgAddToObj ( &cntDta.Send , Form );
 	CntMsgAddToObj ( &cntDta.Send , "\nNewline : :\n" );

 	CntMsgAddToObj ( &cntDta.Send , "Label: 1 : " );
 	CntMsgAddToObj ( &cntDta.Send , "request for some reason.\n" );
 	CntMsgAddToObj ( &cntDta.Send , "Newline : :\n" );
   }
   else
   {
   /* Read the form and transmit it to the Client */
 
      while ( !feof(form))
      {
	 int n;
	 n = fread ( Buff , 1 , sizeof(Buff)-6 , form );
	 printf ( "Sending %s" , Buff );
	 Buff[n] = 0;
	 CntMsgAddToObj ( &cntDta.Send , Buff );
      }
   }
}


char * RequestFile = "/tmp/RequestFile";
char * ReplyFile   = "/tmp/ReplyFile";
// char * ReplyProgram = "cat a2 > /tmp/ReplyFile";

char * ReplyProgram = "/vlad/home/hchen4/Agents2Go/classes/runit.sh";

#ifndef OLGA

int ReplyToDataRequest ( char * From , char * Data )
{

   FILE * form;
   char Buff[1024];
   int fail = 0;
   PRINTF ( "Replying to Data request for  %s" , Data );



   /* Dump the request to the file */
   form = fopen ( RequestFile , "w" );
   if ( form == NULL ) fail = -1;

   if ( !fail ) fprintf ( form , "%s" , Data );
   if ( !fail ) fclose  ( form );


   /* Execute the file */
   system ( ReplyProgram );

   /* Read out the report */
   form = fopen ( ReplyFile  , "r" );
   if ( form == NULL ) fail = -1;


   CntMsgInitObj ( &cntDta.Send ,  From );
   cntDta.Send.TimeStamp = cntDta.timeTick+1;



   CntMsgAddToObj ( &cntDta.Send , "R|" );
 
   if ( fail  )
   {
        CntMsgAddToObj ( &cntDta.Send , "Label: 1 : " );
        CntMsgAddToObj ( &cntDta.Send , "Could not process your\n" );
        CntMsgAddToObj ( &cntDta.Send , "Newline : :\n" );

        CntMsgAddToObj ( &cntDta.Send , "Label: 1 : " );
        CntMsgAddToObj ( &cntDta.Send , "request for some reason.\n" );
        CntMsgAddToObj ( &cntDta.Send , "Newline : :\n" );
   }
   else
   {
   /* Read the form and transmit it to the Client */

      while ( !feof(form))
      {
         int n;
         n = fread ( Buff , 1 , sizeof(Buff)-6 , form );
         printf ( "Sending %s" , Buff );
         Buff[n] = 0;
         CntMsgAddToObj ( &cntDta.Send , Buff );
      }
      fclose ( form );
   }
}

#else

/**** OLGA SHOULD USE THIS FUNCTION ******/
int ReplyToDataRequest ( char * From , char * Data )
{

   FILE * form;
   char Buff[1024];
   int fail = 0;
   PRINTF ( "Replying to Data request for  %s" , Data );



   /* Dump the request to the file */
   form = fopen ( RequestFile , "w" );
   if ( form == NULL ) fail = -1;

   if ( !fail ) fprintf ( form , "%s" , Data );
   if ( !fail ) fclose  ( form );


   /* Execute the file */
   system ( ReplyProgram );

   /* Read out the report */
   form = fopen ( ReplyFile  , "r" );
   if ( form == NULL ) fail = -1;


   CntMsgInitObj ( &cntDta.Send ,  From );
   cntDta.Send.TimeStamp = cntDta.timeTick+1;



   CntMsgAddToObj ( &cntDta.Send , "R|" );
 
   if ( fail  )
   {
        CntMsgAddToObj ( &cntDta.Send , "Label: 1 : " );
        CntMsgAddToObj ( &cntDta.Send , "Could not process your\n" );
        CntMsgAddToObj ( &cntDta.Send , "Newline : :\n" );

        CntMsgAddToObj ( &cntDta.Send , "Label: 1 : " );
        CntMsgAddToObj ( &cntDta.Send , "request for some reason.\n" );
        CntMsgAddToObj ( &cntDta.Send , "Newline : :\n" );
   }
   else
   {
   /* Read the form and transmit it to the Client */

      while ( !feof(form))
      {
         int n;
//         n = fread ( Buff , 1 , sizeof(Buff)-6 , form );
         printf ( "Sending %s" , Buff );
         Buff[strlen(Buff)] = 0;
         CntMsgAddToObj ( &cntDta.Send , Buff );
      }
      fclose ( form );
   }
}
#endif






int ReplyToMessage  ( char * From ,  char * Msg )
{
  /* Message Reply thing */
  char Request[88];
  int stPtr = 0;

  PRINTF ( "Replying to %s \n" , Msg );

  /* Start Parsing */

  /* Does message start with | ? */

  if ( * Msg != '|' ) return -1;

  Msg++;

  while ( *Msg != '\0'  &&
	  *Msg != '|' )
  {
     Request[stPtr++] = *Msg;
     if ( stPtr > 80 ) return -1;
     Msg++;
  }
  if ( *Msg == 0 ) return -1;
  if ( *Msg != '|' ) return -1;

  Msg++;
  Request[stPtr] = 0;

  PRINTF ( "Command is %s \n" , Request );

  if ( !strcmp ( Request , "FormRequest" )) 
		ReplyToFormRequest ( From , Msg );
  if ( !strcmp ( Request , "FormData" )) 
		ReplyToDataRequest ( From , Msg );
  if ( !strcmp ( Request , "XmlRequest" )) 
		ReplyToXmlRequest ( From , Msg );
  
  return 0;
}


void CntMessageReceived ( int i )
{

   char SendTo[40];
   CntMsgObj * msgObj =  &cntDta.Rcv[i];
   int c;
   int usrDone = 0;
   int m;
   int j = 0;

   char Message[16000];

   memset ( Message , 0 , sizeof(Message));

   PRINTF ( "CENTAURUS MESSAGE HAS BEEN RECEIVED " );
   PRINTF ( "MESSAGE #### %d " , i );

   PRINTF ( "Message Received\nObj %s \nTime %d \nSize %d",
	      msgObj->Id , msgObj->TimeStamp, msgObj->Size );
   i = 0;
   
   PRINTF ( "Message is\n--------------------------------------");
     while ( c = CntMsgNextChar ( msgObj ) ) 
	{
	   if ( c == '|' ) usrDone = -1;
	   if ( !usrDone )  SendTo[i++] = c; 
		      else  Message[j++] = c;
	   putchar ( c );
	}
   PRINTF ( "\n--------------------------------------");
   SendTo[i] = 0;
   Message[j] = 0;

#ifdef SERVER
   i = CntDevForUser (SendTo);
#else
   i = 0;
#endif

   if ( i == -1 ) { PRINTF ("INVALID USER %s " , SendTo ); return ; }

   /* Find out what we have we either have a request for form or
      we have something else
    */
    
   PRINTF ( "The message body is\n---------------\n%s\n-------------",
	    Message );

   PRINTF ( "Context is %d " , i );

#ifdef SERVER
    SwitchContext ( i );
#endif

   if ( ReplyToMessage ( SendTo, Message ) ) PRINTF ( "BAD RESULTS" );

#ifdef SERVER
   SwitchContext ( i );
#endif

   PRINTF ( "Sending to %s at %d \n" , SendTo , i );
   
}

int ObjAcptCallback ( char * Name )
{
  printf ( "Accepting New Client  %s \n" , Name );
  ObjAccept ( Name );

}

int main ()

{
   int i, actCode;


   puts ( "Testing UDP/Centaurus" );



   /* Start-Up Centaurus */
   CntStart ();

   ObjNewObjSetCb   ( &cntDta ,  ObjAcptCallback );

 //   ObjAccept ( "FormRequest" );
 //   ObjAccept ( "FormData" );
   

   for ( ;; )
   {
     /* This should go to the nilEvent processing */
	
	for ( i = 0 ; i < MAX_OBJECTS ; i ++ )
	{
	     if ( cntDta.Completed[i] != 0 )
	     {
		 CntMessageReceived ( i );
		cntDta.Completed [i] = 0;
	     }
	}

 switch ( actCode = CntXFerAction () )
	{
	case cntActNone:
		break;
	case cntActSetName:
	  puts ( "Set Name" );
	       printf ( "Enter username " );
	       strcpy ( UserName , "A2GoServer" );
	       CntSetUserName ( UserName );
	  break;

	case cntActUpdateDiscovery:
	  // printf ( "Discovery Timeout is in %d \n" , cntDta.DiscoveryTimeout );
	  break;

#ifdef SERVER
	case cntActUpdateDevicelist:
	  puts ( "Active Devices :" );
	
	  for ( i = 0 ; i < cntDta.nGoodDevices ; i ++ )
	  {
	     printf ( "   Device :  %s \n" , cntDta.DeviceList[i] );
	  }

	  break;	  
#endif
		
	default:
	  PRINTF ( "PANIC: Unkown Action %d requested " , actCode );
	  
         }
      

   }

}
