/*** Constants ****/
#define MAX_RECORD_SIZE   (3 + 256 + 4096)
#define CUSTOM_FIELD_SIZE 16


/*********************** CALL BACK STUFF ***************************/
register void *reg_a4 asm ("%a4");
#define CALL_PROLOGUE  void *save_a4=reg_a4; asm("move.l %%a5,%%a4; sub.l #edata ,%%a4" \
 	 : : ); 
#define CALL_EPILOGUE reg_a4 = save_a4; 
 


/* NetForm AppInfo Type */
typedef struct {
  Word renamedCategories;
  Char categoryLabels[dmRecNumCategories][dmCategoryLength];
  Byte categoryUniqIDs[dmRecNumCategories];
  Byte lastUniqID;
  /* end of AppInfoType structure, start of custom fields */
  Byte displayStyle;
  Byte writeProtect;
  Byte lastCategory;
  UInt CurrentRec;
  
  Char customField1[CUSTOM_FIELD_SIZE];
  Char customField2[CUSTOM_FIELD_SIZE];

  Char WordList[1024];
  Char padding[200];
} NetFormAppInfoType;



/* Temp database record */
typedef struct 
{
   int Score;
   int Category;
 
   /** TEMP SOLUTION */

   char Word [ 40 ];
   char Def  [ 1024 ];

} Record;


int FillDatabase ( char * Name );
void ReadDatabaseInfo( ) ;
void RetrieveWords ( CharPtr WordList );
void CloseDatabase ();
void SaveAddWordList ( CharPtr WordList );
VoidHand GetAddWordList ();

int  StartToCommunicate ();
void SendWord ( char * Word ); 
int  GetDefinitions ();
void CloseCommunication ();



// Define the minimum OS version we support
#define ourMinVersion	sysMakeROMVersion(2,0,0,sysROMStageRelease,0)
#define NetFormWordDBType	'Word'		
#define memoDBName		"MemoDB"
#define noRecordSelected	-1		


extern DmOpenRef CurrentDB;  /* Pointer to the database */
extern int CurrentRecord;	  /* The currrent record number */
extern Word TopVisibleRecord;	  /* index of the top most record being displayed (main form) */
extern Word TopVisibleField;	  /* Index of the top most field in the table (edit form) */
 
extern const unsigned long  NetFormFileCreator ;
extern const unsigned short appVersionNum ;
extern const unsigned short appPrefID ;
extern const unsigned short appPrefVersionNum ;
extern const unsigned long  version20 ;


extern Record Rec;
