#include <Pilot.h> 
#include <SysEvtMgr.h> 
#include <Unix/sys_socket.h> 
#include "NetForm.h"
#include "AgentsRes.h"




ctlDef nForm [ FRM_MAXFIELD ];


/* Form Processing Functions */

CharPtr NextToken ( CharPtr ptr )
{
    ptr++;
    if ( ! *ptr ) return ptr;
    while ( *ptr != 0 )
	switch ( *ptr )
	{
	    case ':':
	    case '\0':
		*ptr = 0;
	        break;
	    default:
		ptr++;
	}

    return ptr;	 


}

int ProcessField ( int Num ,  CharPtr Fld )
{
   CharPtr Cls , Id , Tkn;

   /* Get Class */
   Tkn = Fld; Fld = NextToken ( Fld );

   switch ( *Tkn )
   {
       case 'G':  /* Goto */
	   nForm[Num].Class = Goto;
	   break;
       case 'F':  /* Field */
	   nForm[Num].Class = Field;
	   break;
       case 'L':  /* Label/List */
	  switch ( *(Tkn+1))
	  {
	   case 'a':  /* Label */
	   nForm[Num].Class = Label;
	   break;
	   case 'i':  /* List */
	   nForm[Num].Class = List;
	   break;
	  }
	  break;
       case 'B': /* TrueFalse */
	   nForm[Num].Class = TrueFalse;
	   break;
       case 'N':
	   nForm[Num].Class = NewLine;
   }
   
   /* Get ID    */
   Tkn = Fld; Fld = NextToken ( Fld ); Tkn++;
   StrCopy ( nForm[Num].ID , Tkn );

   switch ( nForm[Num].Class ) { case Goto: case NewLine: return 0; }

   
   Tkn = Fld; Fld = NextToken ( Fld ); Tkn++;
//   FrmCustomAlert ( DbProblemsAlert , Tkn , NULL , NULL );
   if ( nForm[Num].Class != List )
     StrCopy ( nForm[Num].Data.Text , Tkn );
     


   return 0;    

     
   /* Get class specific data */

}
