/*************************************************************
File    : CntXFerUtil.c		
Contains: Utility functions for Centaurus
Author  : Vlad Korolev
Last Mod: Tue Oct  3 12:46:34 EDT 2000
History : 
Tue Oct  3 12:47:29 EDT 2000   Comments added
**************************************************************/

/**************************************************************
   Function    :    MemCopy
   Purpose     :    Copy block of memory from one location
                    to the other. Written for compatibilty
		    reasons
   TODO        :    Convert to macro with fallback to system
                    funcions
**************************************************************/
void MemCopy ( char * Dest , char * Src , int l )
{
  int i;
  for ( i = 0 ; i < l ; i ++ ) Dest[i] = Src[i];
}

void MemSet (char *Dest, int l, int c)
{
  int i;
  for (i=0; i<l; i++) Dest[i] = c;
}
