/******************************************************************
File		: SushIRData
Contains	: IRDA dependant portions of Sush Protocol
******************************************************************/


#ifdef __LINUX__
#define   IrRefType  void *
#else
#define   IrRefType  UInt
#endif


/**********************************************************************
			IRDA  VARIABLES
**********************************************************************/


/// IRDA STRINGS


extern char *ir_event_str[];
extern char *ir_ias_return_str[];
extern char *ir_ias_type_str[];
extern char *ir_ias_encoding[];
extern char *ir_status_str[];

// IRDA  Objects 

extern IrRefType ir_ref;
extern char dev_name[];
extern IrConnect con;
extern IrIasObject ias_object;
extern IrIasAttribute attribs[];
extern IrIasQuery query;

// IAS :: Attributes

extern char *ias_name;
extern char *attr_name        [] ;
extern char attr_rsap         [] ;
extern char attr_username     [] ;



extern char rlsap_dev_query[];
extern char rlsap_lmp_query[];
extern char rlsap_usr_query[];
extern char result[];
extern int  rlsap,rtype;

extern IrPacket packet;

/***** IRDA CALLBACKS */

void IrCallback(IrConnect *connect, IrCallBackParms *parms) ;

