/* 
     Centaurus X-FER  data types and prototypes that
     are specific to UDP
*/

#ifdef __LINUX__
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <unistd.h>
#else
#include <Unix/sys_types.h>
#include <Unix/sys_socket.h>
#include <Unix/netdb.h>
#include <Unix/netinet_in.h>
#include <Unix/netdb.h>
#include <Unix/netinet_in.h>
#endif


typedef struct 
{
   int len;
   char * buff;

} tagPacket;


typedef struct 
{
	int sk;
	struct sockaddr_in local_addr , dest_addr;
} tagCntUDP;

extern tagCntUDP  CntUDP;
extern tagPacket  packet;
extern char CntUserName[40];


#ifndef SERVER
extern struct sockaddr_in Server ; 
extern int    ServerTTL;
#endif

typedef struct sockaddr_in CntDeviceAddr;

#define __CNT_IMPLENENTATION_DEFINED xx
