
#ifndef __LINUX__

extern char PrintTmp [];

#define MAX_LEN   80

#ifdef DEBUG1
#define PRINTF1(format, args...) {StrPrintF(PrintTmp,format, ## args);debug_msg(PrintTmp);}
#else
#define PRINTF1(format,args...){;}
#endif

#ifdef DEBUG2
#define PRINTF2(format, args...) {StrPrintF(PrintTmp,format, ## args);debug_msg(PrintTmp);}
#else
#define PRINTF2(format,args...){;}
#endif

#ifdef DEBUG3
#define PRINTF3(format, args...) {StrPrintF(PrintTmp,format, ## args);debug_msg(PrintTmp);}
#else
#define PRINTF3(format,args...){;}
#endif

#ifdef DEBUG4
#define PRINTF4(format, args...) {StrPrintF(PrintTmp,format, ## args);debug_msg(PrintTmp);}
#else
#define PRINTF4(format,args...){;}
#endif

#define PRINTF(format, args...) {StrPrintF(PrintTmp,format, ## args);debug_msg(PrintTmp);}

void UpdateDbgWnd (void);
void DbgWinInit (void);
void debug_msg(char *msg) ;
void scroll_down(void) ;
void scroll_up(void) ;
void update(void) ;


#else

// __inline void Nothing () {}

#include <stdio.h>

#ifdef  DEBUG1
#define PRINTF1(format, args...) {printf( "%d : ", cntDta.timeTick ); printf(format , ## args); puts("");fflush(stdout);}
#else
#define PRINTF1(format,args...){;}
#endif


#ifdef  DEBUG2
#define PRINTF2(format, args...) {printf( "%d : ", cntDta.timeTick );printf(format , ## args); puts("");fflush(stdout);}
#else
#define PRINTF2(format,args...){;}
#endif

#ifdef  DEBUG3
#define PRINTF3(format, args...) {printf( "%d : ", cntDta.timeTick );printf(format , ## args); puts("");fflush(stdout);}
#else
#define PRINTF3(format,args...){;}
#endif

#ifdef  DEBUG4
#define PRINTF4(format, args...) {printf( "%d : ", cntDta.timeTick );printf(format , ## args); puts("");fflush(stdout);}
#else
#define PRINTF4(format,args...){;}
#endif

#define PRINTF(format, args...) {printf( "%d : ", cntDta.timeTick ); printf(format , ## args); puts("");fflush(stdout);}



#define UpdateDbgWind     Nothing
#define scroll_down       Nothing
#define debug_msg	  puts
#define scroll_up	  Nothing 
#define update		  Nothing


#endif
