#include <Str.h>
#include <DebugWnd.h>
#include <callback.h>
#include <CntXFer.h>
#include <stdlib.h>
#ifdef __LINUX__
#include <sys/time.h>
#include <unistd.h>
#endif

#define MICRO		0.000001
#define MAX_SIZE	8192
#define MAX_MSGS	10
#define TINY            32
#define LARGE           64

/* Platform specific timing crap */
/*
  TIME_VALUE   --- data type of the time value
  RECORD_TIME  --- action to record the current time
  TIME_DIFF    --- output time difference in seconds
*/
#ifdef __LINUX__
 
typedef struct timeval TIME_VALUE;
 
 
#define RECORD_TIME(c) gettimeofday(&c,0);
 
char * TimeDiff (TIME_VALUE *a , TIME_VALUE *b )
{
      static char Tmp[89];
      double d =  (double)(b->tv_sec - a->tv_sec)+
           MICRO*(double)(b->tv_usec - a->tv_usec);
 
      sprintf ( Tmp , "%lf" , d );
      return Tmp;
}
 
#define TIME_DIFF(a,b) TimeDiff(&a,&b);
 
#else
MinstrelData Data ;
typedef ULong TIME_VALUE;
//char * TimeDiff(ULong a, ULong b);
double ticksPerSecond;
char * TimeDiff (ULong a, ULong b)
{
   static char Tmp[80] = "Sucks";
   StrPrintF ( Tmp, "%ld" ,  b - a );
 
   {
        Long TickDiff = b - a;
        double x = longToDouble (TickDiff);
 
        x = mulDouble ( x , ticksPerSecond );
        printDouble ( x , Tmp );
        Tmp[6] = 0;
 
   }
 
   return Tmp;                                                              
}
#define RECORD_TIME(c) (c = TimGetTicks());
#define TIME_DIFF(a,b) TimeDiff(a,b);
#endif                                                                         

char ClientUserName[40] = "", ServerUserName[40]="";
char DataName[40]="client";
static int NeedCtrl=0;
TIME_VALUE Start;

void ProcessMessage(int objnum, char* SName, char *type, char *buffer)
{
  CntMsgObj * msgObj =  &cntDta.Rcv[objnum];
  int c;

  SName[0] = 0;
  while ((c = CntMsgNextChar(msgObj)) != '|')
    StrCat(SName, &c);


  sscanf(msgObj->Packets[(msgObj->NxtPtr)/128].PktData+ (msgObj->NxtPtr%128)  , "%c ", type); 
}

int PrepareHello(int snum, int rsize, int ssize, char *DataBuffer)
{

  char infobuf[20];
  int i,j=0;

  CntMsgInitObj ( &cntDta.Send , "ClientObj" );
  CntMsgAddToObj (  &cntDta.Send , ClientUserName );
  CntMsgAddToObj (  &cntDta.Send , "|H" );

  sprintf(infobuf, "%d %d %d |", rsize, ssize, snum);

  printf( "Infobuf is %s \n" , infobuf );

  CntMsgAddToObj (  &cntDta.Send , infobuf);

  j = ssize - StrLen ( infobuf );
  j -= 30;
  for (i=0; i < j  ; i++) 
    DataBuffer[i] = (random() % 96)+32;

  CntMsgAddToObj (  &cntDta.Send , DataBuffer);
  cntDta.Send.TimeStamp = cntDta.timeTick+1;
  printf ( "SENDING OBJ : Size %d \n" , cntDta.Send.Size );
  for(;;) {
    CntXFerAction();
    if (cntDta.Send.Id[0] == 0) return 0;
  }
}

void WaitForMessage(char* ServerUserName, char* MsgType, char* DataBuffer)
{
  int i, flag = 0;

  while(!flag) {
    for ( i = 0 ; i < MAX_OBJECTS ; i ++ )
      {
	if ( cntDta.Completed[i] != 0 )
	  {
	    ProcessMessage(i, ServerUserName, MsgType, DataBuffer);
	    cntDta.Completed[i] = 0;
	    flag = -1;
	    break;
	  }
      }
    CntXFerAction();
  }
}

int PrepareNSendGoodbye(int snum, TIME_VALUE Mid, TIME_VALUE End, char *DataBuffer)
{
  char *diff;

  CntMsgInitObj ( &cntDta.Send , "ClientObj" );
  CntMsgAddToObj (  &cntDta.Send , ClientUserName );
  CntMsgAddToObj (  &cntDta.Send , "|G" );
  
  sprintf(DataBuffer, "%d %s M", snum, DataName);
 
  diff = TIME_DIFF(Start, Mid)
  StrCat(DataBuffer, diff);
  StrCat(DataBuffer, " ");

  diff = TIME_DIFF(Mid, End)
  StrCat(DataBuffer, diff);

#ifndef __LINUX__
  if ( Data.CntRSSI == 0   ) Data.CntRSSI   = 1;
  if ( Data.CntMDBusy == 0 ) Data.CntMDBusy = 1;
  if ( Data.CntBLER == 0   ) Data.CntBLER   = 1;
  if ( Data.CntrBLER == 0  ) Data.CntrBLER  = 1;
  
  sprintf ( diff , " %d %d %d %d %d " ,
	    Data.UpdNum , Data.NoSignl,
	    -113 + Data.TtlRSSI / Data.CntRSSI ,
	    -113 + Data.MinRSSI,
	    -113 + Data.MaxRSSI );
  StrCat  ( DataBuffer , diff );
  
  sprintf ( diff , " %d %d %d " ,
	    Data.TtlBLER / Data.CntBLER ,
	    Data.MinBLER,
	    Data.MaxBLER );
  StrCat  ( DataBuffer , diff );
  
  sprintf ( diff , " %d %d %d " ,
	    Data.TtlrBLER / Data.CntrBLER ,
	    Data.MinrBLER,
	    Data.MaxrBLER );
  StrCat  ( DataBuffer , diff );
  
  sprintf ( diff , " %d %d %d " ,
	    Data.TtlMDBusy / Data.CntMDBusy ,
	    Data.MinMDBusy,
	    Data.MaxMDBusy );
  StrCat  ( DataBuffer , diff );
  StrCat  ( DataBuffer, 0);
  
  MinstrelResetStats  (&Data);
#endif
  
  CntMsgAddToObj (  &cntDta.Send , DataBuffer);
  cntDta.Send.TimeStamp = cntDta.timeTick+1;
  for(;;) {
    CntXFerAction();
    if (cntDta.Send.Id[0] == 0) return 0;
  }
}

int ExecuteSession(int session_num, int req_msg_size, int sent_msg_size, int NeedCtrl)
{

  char MsgType, *diff;
  static char DataBuffer[MAX_SIZE], Pad[128];
  TIME_VALUE Mid, End;
  int done;

#ifndef __LINUX__
  if ( ! (pktnum % 10 )) UpdatePreferences ( session_num,sent_msg_size);
 
  RECORD_TIME(Current)
  if ( Current - LastStat > SysTicksPerSecond() *20 )
    {
      // Suck out all the junk from the modem
      MinstrelAutoRequest ( &Data , 1 , 0 );
      sleep(3);
      ReceiveMinstrelData ();
    }
  MinstrelResetStats  (&Data);
  MinstrelAutoRequest ( &Data , 1 , 100 );
  RECORD_TIME(LastStat)
#endif                                                                         

  printf ( "Session %d %d \n" , session_num , sent_msg_size );

  if (NeedCtrl) {
   CntMsgInitObj (   &cntDta.Send , "ClientObj" );
   CntMsgAddToObj (  &cntDta.Send , ClientUserName );
   CntMsgAddToObj (  &cntDta.Send , "|C" );

   for(;;) {
     CntXFerAction();
     if (cntDta.Send.Id[0] == 0) return -1;
   }
  }

  RECORD_TIME (Mid)
  done = PrepareHello(session_num, req_msg_size, sent_msg_size, DataBuffer);

  WaitForMessage(ServerUserName, &MsgType, DataBuffer);

  RECORD_TIME (End)

  if (MsgType != 'P') {
    PRINTF("Unexpected Message Type %c\n...Exiting\n",MsgType);
    return -2;
  }
  else
    done = PrepareNSendGoodbye(session_num, Mid, End, DataBuffer);
}
                                                                         
int main ()

{
   int done, actCode, session_num=0, req_msg_size=TINY, sent_msg_size=8192;
   int NeedCtrl = 0, rnd;


   /* Start-Up Centaurus */
   CntStart ();

   RECORD_TIME(Start)

   ObjAccept ( "ClientObj" );

   switch ( actCode = CntXFerAction () )
     {
     case cntActNone:
       break;
     case cntActSetName:
       srand(time(NULL));
       rnd = 1+(int) (10000.0*rand()/(RAND_MAX+1.0));
       sprintf(ClientUserName, "%d", rnd);
       CntSetUserName(ClientUserName);
       StrCat(DataName,ClientUserName);
       break; 
     default:
       PRINTF ( "PANIC: Unkown Action %d requested " , actCode );           
     }

   for ( ;; )
   {
     done = ExecuteSession(session_num, sent_msg_size, req_msg_size, NeedCtrl);
     if (done == -1) {
       PRINTF("Control Code Received...Exiting\n");
       exit(-1);
     }
     if (session_num++ == MAX_MSGS) {
        session_num = 0;
        sent_msg_size *= 2;
      }
      if (sent_msg_size > MAX_SIZE)
        break;

      RECORD_TIME(Start)
    }
}                

