#include "CentMsg.h"


#ifdef PALM_PILOT
#define BUFF_TYPE CntMsgObj *
#define ADD_TO_OBJ CntMsgAddToObj
#else
#define BUFF_TYPE char *
#define ADD_TO_OBJ strcat
#endif




void MakeMessage  ( BUFF_TYPE CntMsg , CentaurusMessage * msg )
{
   
  


}


#ifndef PALM_PILOT

void PrintCentMsg ( CentaurusMessage * msg )
{
    puts ( " ---- CCML MESSAGE ---- " );

   /* Print out System */
     puts ( msg->full ? "full":"diff" );
     puts ( msg->command ? "command" : "update" );
     if ( msg->valid )  puts ( "valid" );
     if ( msg->public )  puts ( "public" );
     if ( msg->interactive ) puts ( "interactive" );

     printf ( "Id       :  %40s \n" , msg->id );
     printf ( "Manager  :  %40s \n" , msg->manager );
     printf ( "Time     :  %8d  \n" , msg->time     );
     printf ( "Origin   :  %40s \n" , msg->origin  );
     printf ( "Location :  %40s \n" , msg->location );
     printf ( "Parent   :  %40s \n" , msg->parent   );


   
   /* Print out AddOns */


   /* Print out data   */


   /* Printout interfaces */


   /* Printout Info     */ 

}

#endif

int  CheckCentMsg ( CentaurusMessage * msg )
{
    if ( msg->time == -1 ) return -1;
    if ( msg->command == -1 ) return -1;
    if ( msg->full == -1 ) return -1;

    if ( msg->id[0] == 0 ) return -1;
    if ( msg->manager[0] == 0 ) return -1;
    if ( msg->origin[0] == 0 ) return -1;
    if ( msg->location[0] == 0 ) return -1;
}


void InitCentMsg ( CentaurusMessage * msg )
{

    msg->id[0] = 0;
    msg->manager[0] = 0;
    msg->origin[0] = 0;
    msg->location[0] = 0;
    msg->parent[0] = 0;
    msg->time      = -1;

    msg->full = -1;
    msg->command = -1;
    msg->valid = 0;
    msg->public = 0;


}


#ifdef NEVER_ACTIVATE

void main ()
{


   CentaurusMessage msg;

   InitCentMsg ( &msg );

   PrintCentMsg ( &msg );



}


#endif
