#define MAX_ENTITY 12
#define MAX_ENT_NAME 40
#define MAX_ENT_VAL 128

typedef struct
{
  int * Index;
  char * Encoded;
} TagAttr; 

typedef enum 
{ 
  match , 
  notmatch , 
  space , 
  any 
} CondKind;

typedef enum 
{ 
  xmlParseTag    , 
  xmlParseTagEnd , 
  xmlParseCDATA  , 
  xmlParseDocType 
} xmlParseAction;


typedef enum { 
  xmlParseOk, 
  xmlParseAbort, 
  xmlParseError,
  xmlParseNoSanity
} xmlParseResult;


typedef struct
{
  char   EntName [MAX_ENT_NAME];
  char   EntVal  [MAX_ENT_VAL ]; 
  char   intPtr;
} EntEntry;

typedef struct 
{
  CondKind k;
  char  inp;
  int   goTo;
} stCond; 

typedef struct
{
  stCond         * conds;
  int      	  action;
} State;




/* Entity related variables */
extern EntEntry Entities  [MAX_ENTITY];		/* Enitity data storage  */
extern int      freeEnt;			/* Next available entity */
extern int      currentEnt ;			/* Current Enity that we are writing into */
extern int 	currentEntNamePos ;		/* Current Position in the entity name   */
extern int 	currentEntValPos  ;		/* Current Position in the entity value  */


#ifndef PALM_PILOT
void Error ( char * st );
#endif
int  matchInput (int state , int c);
void DoParse ();

void PrintAttrs ( int Tag , TagAttr * attr );
int  GetAttrIdx ( TagAttr * attr , int Tag );


/* Provided callbacks */
xmlParseResult DoParseAction ( int a , int inp );


extern State States[] ;


xmlParseResult XmlParseCallback ( xmlParseAction  a ,   int Tag , void * arg  );
